/*
* Copyright (c) 2019-2021 NXP.
* All rights reserved.
*/

#if defined(CPU_MIMXRT1061DVL6A)
#include "system_MIMXRT1061.h"
#elif defined(CPU_MIMXRT1062DVL6A)
#include "system_MIMXRT1062.h"
#elif defined(CPU_MIMXRT1064DVL6A)
#include "system_MIMXRT1064.h"
#elif defined(CPU_MIMXRT1176DVMAA_cm7)
#include "system_MIMXRT1176_cm7.h"
#elif defined(CPU_MIMXRT1176DVMAA_cm4)
#include "system_MIMXRT1176_cm4.h"
#elif defined(CPU_MIMXRT1175DVMAA_cm7)
#include "system_MIMXRT1175_cm7.h"
#elif defined(CPU_MIMXRT1175DVMAA_cm4)
#include "system_MIMXRT1175_cm4.h"
#elif defined(CPU_MIMXRT1173DVMAA_cm7)
#include "system_MIMXRT1173_cm7.h"
#elif defined(CPU_MIMXRT1173DVMAA_cm4)
#include "system_MIMXRT1173_cm4.h"
#elif defined(CPU_MIMXRT1171DVMAA_cm7)
#include "system_MIMXRT1171_cm7.h"
#elif defined(CPU_MIMXRT1171DVMAA_cm4)
#include "system_MIMXRT1171_cm4.h"
#endif

#include "clock_config.h"

#include "MW_target_hardware_resources.h"


unsigned long schdl_counter;
unsigned long schdl_counter_max;

extern void rt_OneStep();
#ifdef PERIODIC_TASK_STEP
    extern void PERIODIC_TASK_STEP_FCT;
#endif // PERIODIC_TASK_STEP


void SysTick_Handler(void)
{
    if (schdl_counter >= schdl_counter_max) {
        schdl_counter = 0;
    }

    if (0 == schdl_counter++) {  /* Compare with zero before increament */
#if defined(PERIODIC_TASK_STEP) && PERIODIC_TASK_STEP == 1
        PERIODIC_TASK_STEP_FCT;
#else
        rt_OneStep();
#endif
    }

#ifdef USE_ETH
    time_isr();
#endif
}
void imxrt_trigger_config(float modelBaseRate)
{
	/* SysTick Scheduler is selected */
	unsigned long tick_counter;
    tick_counter = (unsigned long)(SystemCoreClock * modelBaseRate);

	if (tick_counter > SysTick_LOAD_RELOAD_Msk) {
		schdl_counter_max = (unsigned long)((float)tick_counter / (float)SysTick_LOAD_RELOAD_Msk) + 1;
		SysTick_Config(tick_counter/schdl_counter_max);		
	} else {
		schdl_counter_max = 0;
		SysTick_Config(tick_counter);
	}
	
	schdl_counter = 0;
	
	/* Set the SysTick priority */
	#ifdef MW_SCHEDULER_PRIORITY
		NVIC_SetPriority((IRQn_Type)(-1), MW_SCHEDULER_PRIORITY);
	#endif
        
}
