/*
 * File: Blinky.c
 *
 * Code generated for Simulink model 'Blinky'.
 *
 * Model version                   : 1.145
 * Simulink Coder version          : 9.3 (R2020a) 18-Nov-2019
 * MBDT for IMXRT Series Version :  Version 1.3.0 (R2019a-R2021b) 18-Apr-2022
 * C/C++ source code generated on  : Sat Nov 26 13:09:17 2022
 *
 * Target selection: ert.tlc
 * Embedded hardware selection: ARM Compatible->ARM Cortex
 * Code generation objective: Execution efficiency
 * Validation result: All passed
 */

#include "Blinky.h"
#include "Blinky_private.h"

/* Named constants for Chart: '<Root>/Chart' */
#define Blinky_IN_State0               ((uint8_T)1U)
#define Blinky_IN_State1               ((uint8_T)2U)

/* Block signals and states (default storage) */
DW_Blinky_T Blinky_DW;

/* Previous zero-crossings (trigger) states */
PrevZCX_Blinky_T Blinky_PrevZCX;

/* External outputs (root outports fed by signals with default storage) */
ExtY_Blinky_T Blinky_Y;
static void init_freemaster_lpuart(void)
{
  lpuart_config_t config;
  LPUART_GetDefaultConfig(&config);
  config.baudRate_Bps = 115200;
  config.enableTx = false;
  config.enableRx = false;
  LPUART_Init(LPUART1, &config, BOARD_DEBUG_UART_CLK_FREQ);

  /* Register communication module used by FreeMASTER driver. */
  FMSTR_SerialSetBaseAddress(LPUART1);

#if FMSTR_SHORT_INTR || FMSTR_LONG_INTR

  /* Enable UART interrupts. */
  EnableIRQ(LPUART1_IRQn);
  EnableGlobalIRQ(0);

#endif

}

void LPUART1_IRQHandler()
{
  FMSTR_SerialIsr();
}

/* Model step function */
void Blinky_step(void)
{
  uint8_T rtb_LED;

  /* S-Function (imxrt_gpio_input): '<Root>/GPIO_Input' incorporates:
   *  Outport: '<Root>/Button'
   */
  Blinky_Y.Button = GPIO_PinRead(GPIO5, 0U);

  /* Outputs for Triggered SubSystem: '<Root>/Function-Call Subsystem' incorporates:
   *  TriggerPort: '<S2>/function'
   */
  /* Outport: '<Root>/Button' */
  if (Blinky_Y.Button && (Blinky_PrevZCX.FunctionCallSubsystem_Trig_ZCE !=
                          POS_ZCSIG)) {
    /* S-Function (imxrt_lpuart): '<S2>/LPUART Data Transfer' incorporates:
     *  Constant: '<S2>/Constant1'
     */
    LPUART_WriteBlocking(LPUART1, Blinky_ConstP.Constant1_Value, 30);
  }

  Blinky_PrevZCX.FunctionCallSubsystem_Trig_ZCE = Blinky_Y.Button;

  /* End of Outputs for SubSystem: '<Root>/Function-Call Subsystem' */

  /* Chart: '<Root>/Chart' */
  if (Blinky_DW.is_active_c3_Blinky == 0U) {
    Blinky_DW.is_active_c3_Blinky = 1U;
    Blinky_DW.is_c3_Blinky = Blinky_IN_State0;
    rtb_LED = 0U;
  } else if (Blinky_DW.is_c3_Blinky == Blinky_IN_State0) {
    Blinky_DW.is_c3_Blinky = Blinky_IN_State1;
    rtb_LED = 1U;
  } else {
    /* case IN_State1: */
    Blinky_DW.is_c3_Blinky = Blinky_IN_State0;
    rtb_LED = 0U;
  }

  /* End of Chart: '<Root>/Chart' */

  /* Outport: '<Root>/LED' */
  Blinky_Y.LED = rtb_LED;

  /* DataTypeConversion: '<Root>/Data Type Conversion' */
  Blinky_DW.DataTypeConversion = (rtb_LED != 0);

  /* S-Function (imxrt_gpio_output): '<Root>/GPIO_Output' */
  GPIO_PinWrite(GPIO1, 9U, Blinky_DW.DataTypeConversion);
}

/* Model initialize function */
void Blinky_initialize(void)
{
  /* Start for S-Function (imxrt_fm_config): '<Root>/FreeMASTER Config' */
  init_freemaster_lpuart();
  FMSTR_Init();
  Blinky_PrevZCX.FunctionCallSubsystem_Trig_ZCE = POS_ZCSIG;
}

/* Model terminate function */
void Blinky_terminate(void)
{
  /* (no terminate code required) */
}

/*
 * File trailer for generated code.
 *
 * [EOF]
 */
